/******************************************************************************************************************
//
//
//
//
//
//
/******************************************************************************************************************/




#include "CCamera.h"
#include <glu.h>
#include <gl.h>



//----------------------------------------------------------------------------------------
// CCamera()
//----------------------------------------------------------------------------------------
CCamera::CCamera()
{
	this->Position = new CVector();
	this->Look = new CVector();
}


//----------------------------------------------------------------------------------------
// ~CCamera()
//----------------------------------------------------------------------------------------
CCamera::~CCamera()
{
	delete this->Position;
	delete this->Look;
}


//----------------------------------------------------------------------------------------
// SetupPosition()
//----------------------------------------------------------------------------------------
int CCamera::SetupPosition(void)
{
	gluLookAt(this->Position->x, this->Position->y, this->Position->z,  
		      this->Look->x, this->Look->y, this->Look->z,  
			  0, 1, 0);	
 return 0;
}

//----------------------------------------------------------------------------------------
// ChangeRoll()
//----------------------------------------------------------------------------------------
void CCamera::ChangeRoll(float new_roll)
{
	this->roll = new_roll;
}


//----------------------------------------------------------------------------------------
// ChangeYaw()
//----------------------------------------------------------------------------------------
void CCamera::ChangeYaw(float new_yaw)
{
	this->yaw = new_yaw;
}


//----------------------------------------------------------------------------------------
// ChangePitch()
//----------------------------------------------------------------------------------------
void CCamera::ChangePitch(float new_pitch)
{
	this->pitch = new_pitch;
}


int CCamera::MoveTo(CVector* NewPosition)
{
	if(NewPosition)
		this->Position = NewPosition;
	else
		return 1;

 return 0;
}


int CCamera::LookAt(CVector* ViewPoint)
{
	if(ViewPoint)
		this->Look = ViewPoint;
	else
		return 1;

 return 0;
}