// CFire.cpp

#include "CFire.h"
#include "CParticleEmitter.h"
#include <gl.h>



//----------------------------------------------------------------------------------------
// CFire()
//----------------------------------------------------------------------------------------
CFire::CFire(CVector* Location)
{
	this->numActiveParticles			= 0;
	this->maxParticles					= 1;
	this->EmitLocation					= Location;
	this->ParticleList					= new CParticle[this->maxParticles];
//	memset(ParticleList, 0, sizeof(CParticleEmitter)*maxParticles);		// Clear all the data
	this->Texture = new CTexture();
	this->Texture->Load("Resources//Textures//Explosion.bmp");	// Loads the texture so its ready to use
	
	for(int i=0; i<1; i++)
	{
		this->Initialize(numActiveParticles++);
	}
}


//----------------------------------------------------------------------------------------
// ~CFire()
//----------------------------------------------------------------------------------------
CFire::~CFire()
{
	delete [] ParticleList;
}


//----------------------------------------------------------------------------------------
// Initialize()
//----------------------------------------------------------------------------------------
int CFire::Initialize(unsigned int index)
{
	ParticleList[index].width			= 5;
	ParticleList[index].height			= 5;
	ParticleList[index].spread			= 2.0f;
	ParticleList[index].Position.x		= EmitLocation->x + rand()%5*ParticleList[index].spread;
	ParticleList[index].Position.y		= EmitLocation->y + rand()%5*ParticleList[index].spread;
	ParticleList[index].Position.z		= EmitLocation->z + rand()%5*ParticleList[index].spread;
	ParticleList[index].size			= 400.0f;
	ParticleList[index].lifespan		= 5.0f;
	ParticleList[index].velocity		= 0.5f;
	ParticleList[index].color			= 1.0f;
	ParticleList[index].is_active		= true;

 return 0;
}


//----------------------------------------------------------------------------------------
// Update()
//----------------------------------------------------------------------------------------
int CFire::Update(void)
{



 
 return 0;
}

//----------------------------------------------------------------------------------------
// Render()
//----------------------------------------------------------------------------------------
int CFire::Render(void)
{

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_DST_ALPHA);

	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, this->Texture->GetID());
 //   glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

//	glColor3f(1.0f, 0.6f, 0.6f);
	glColor3f(1.0f, 0.8f, 0.4f);
	for(unsigned int i=0; i <this->maxParticles; i++)
	{
		glBegin(GL_QUADS);
		if(this->ParticleList[i].is_active)
		{
			glTexCoord2d(1.0f, 0.0f); glVertex3f(ParticleList[i].Position.x + (ParticleList[i].width * ParticleList[i].size), 
											   ParticleList[i].Position.y - (ParticleList[i].height * ParticleList[i].size), 
											   ParticleList[i].Position.z);
			glTexCoord2d(1.0f ,1.0f); glVertex3f(ParticleList[i].Position.x + (ParticleList[i].width * ParticleList[i].size), 
											   ParticleList[i].Position.y, 
											   ParticleList[i].Position.z); 
			glTexCoord2d(0.0f, 1.0f); glVertex3f(ParticleList[i].Position.x, 
											   ParticleList[i].Position.y, 
											   ParticleList[i].Position.z); 
			glTexCoord2d(0.0f, 0.0f); glVertex3f(ParticleList[i].Position.x, 
											   ParticleList[i].Position.y - (ParticleList[i].height * ParticleList[i].size), 
											   ParticleList[i].Position.z); 
		}
		glEnd();
	}

	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);

 return 0;
}
