#ifndef CParticleEmitter_h
#define CParticleEmitter_h


#include "CTexture.h"


/******************************************************************************************************************
// Class: CVector
/******************************************************************************************************************/
class CVector
{
 public:
	CVector() {x=NULL; y=NULL; z=NULL;}
	CVector(float x_pos, float y_pos, float z_pos) {x = x_pos; y=y_pos; z=z_pos;};

 public:
	float x;
	float y;
	float z;
};



/******************************************************************************************************************
// Class: CParticle
// Desc: 
/******************************************************************************************************************/
class CParticle
{
 public:
	CParticle() {velocity=NULL; size=NULL; color=NULL; lifespan=NULL; spread=NULL; width=NULL; height=NULL; is_active=NULL;}
	CVector Position;
	float velocity;
	float size;
	float color;
	float lifespan;
	float spread;				// How far are the particles spread out from the center point?
	unsigned int width;
	unsigned int height;
	bool is_active;
};



/******************************************************************************************************************
// Class: CParticleEmitter
// Desc:
/******************************************************************************************************************/
class CParticleEmitter
{
 public:
	CParticleEmitter();
	~CParticleEmitter();
	virtual int Render(void) = 0;
	virtual int Update(void) = 0;

 protected:
//	virtual int Emit(unsigned int num);
	virtual int Initialize(unsigned int num) = 0;
	
	CTexture* Texture;
	CParticle* ParticleList;
	CVector* EmitLocation;
	unsigned int maxParticles;
	unsigned int numActiveParticles;
};


#endif