#ifndef CTerrain_h
#define CTerrain_h


#include "CTexture.h"

/******************************************************************************************************************
// Class: CTerrain
// Description:  This class contains all the data structures and functions necessary to build and render a terrain,
// using a heightmap generated by a 2d grayscale bitmap.
/******************************************************************************************************************/
class CTerrain
{
 public:
	CTerrain();
	~CTerrain();
	int LoadRAWGrayScale(char* filename);
	int SetVertexColor(int x, int z);
	int Build(char* filename, int a_size, int a_smoothness);
	int Render(void);

	int getHeight(int x, int z) {return HeightMap[z*size + x];}

 private:
	CTexture* Texture;
	unsigned char* HeightMap;
	int smoothness;
	int size;
};





#endif