/******************************************************************************************************************
//
//
//
//
//
//
/******************************************************************************************************************/



#include "CTerrain.h"
#include "CWorld.h"
#include <gl.h>
#include <glaux.h>



//----------------------------------------------------------------------------------------
// CWorld()
//----------------------------------------------------------------------------------------
CWorld::CWorld()
{
}


//----------------------------------------------------------------------------------------
// CWorld()
//----------------------------------------------------------------------------------------
CWorld::~CWorld()
{
	delete myCamera;
	delete myTerrain;
	delete Rain;
	delete Sun;

}


//----------------------------------------------------------------------------------------
// Init()
// Desc: Set up camera, create map
//----------------------------------------------------------------------------------------
int CWorld::Init(void)
{
	this->myTerrain			= new CTerrain();
	this->myCamera			= new CCamera();
	this->myTerrain->Build("Resources//Terrain.raw", 1024, 16);
	
	this->myCamera->MoveTo(new CVector(502.0f, 150.0f, 804.0f));
	this->myCamera->LookAt(new CVector(476.0f, 265.0f, 111.0f));
	
	this->myCamera->SetupPosition();
	this->Sun			    = new CFire(new CVector(-400.0f, 1500.0f, -100.0f));
	this->Rain				= new CRain(new CVector(500.0f, 300.0f, -50.0f));

	this->Rain->myTerrain = this->myTerrain;
	
 return 0;
}


//----------------------------------------------------------------------------------------
// Animate()
// Desc: Update all object positions and animations
//----------------------------------------------------------------------------------------
int CWorld::Animate(void)
{
	this->Sun->Update();
	this->Rain->Update();

 return 0;
}


//----------------------------------------------------------------------------------------
// Render()
// Desc: Render terrain, objects, and particles
//----------------------------------------------------------------------------------------
int CWorld::Render(void)
{
	glLoadIdentity();
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	
	
	this->myCamera->SetupPosition();

	
	this->Sun->Render();
	this->Rain->Render();
		this->myTerrain->Render();

 return 0;
}